Unit AIG3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG4C_p, UTAFSI_p;

procedure AIG3C(var A :Array of Complex; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var RCOND :Real; var Z :Array of Complex;
                var IERR :Integer);

implementation

procedure AIG3C(var A :Array of Complex; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var RCOND :Real; var Z :Array of Complex;
                var IERR :Integer);
var
I,J,JJ,K,KB,KP1,L,NM1 :Integer;
X :Real;
T :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270;
begin
{ ********************************************************C }
{   OPAEHE METOOM AYCCA C BOPOM BEYEO EMEHTA  C }
{   O CTOY  OEHKA CA OYCOBEHHOCT MATP A.  C }
{ ********************************************************C }
RCOND := 0.0;

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N >=  1 ) and (  M >=  1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','I','G','3','C',IERR);
goto _270;
_20:
IERR := 0;
AFG4C(A,M,N,NLEAD,RCOND,Z,IERR);
if ( IERR =  0 ) 
 then goto _30;
UTAFSI('A','I','G','3','C',IERR);
goto _270;
_30:

{   BCEHE MATP INVERSE(U) }
for K:=1 to N do
 begin
  A[(K-1)+(K-1)*M] := DivC(Cmplx(1.0,0.0),A[(K-1)+(K-1)*M]);
  T :=SubC(Cmplx(0.0,0.0),A[(K-1)+(K-1)*M]);
  J := K - 1;
  I := ((J) Mod (5));
  if ( I =  0 ) 
   then goto _50;
  for JJ:=1 to I do
   begin
    A[(JJ-1)+(K-1)*M] := MulC(T,A[(JJ-1)+(K-1)*M]);
_40:
   end;
_50:
  I := I + 1;
  if ( I >  J ) 
   then goto _70;
  JJ := I;
  while ( JJ<=J ) do
   begin
    A[(JJ-1)+(K-1)*M] := MulC(T,A[(JJ-1)+(K-1)*M]);
    A[(JJ+0)+(K-1)*M] := MulC(T,A[(JJ+0)+(K-1)*M]);
    A[(JJ+1)+(K-1)*M] := MulC(T,A[(JJ+1)+(K-1)*M]);
    A[(JJ+2)+(K-1)*M] := MulC(T,A[(JJ+2)+(K-1)*M]);
    A[(JJ+3)+(K-1)*M] := MulC(T,A[(JJ+3)+(K-1)*M]);
_60:
    inc(JJ,5);
   end;
_70:
  KP1 := K + 1;
  if ( N <  KP1 ) 
   then goto _130;
  for J:=KP1 to N do
   begin
    T := A[(K-1)+(J-1)*M];
    A[(K-1)+(J-1)*M] := Cmplx(0.0,0.0);
    I := ((K) Mod (4));
    if ( I =  0 ) 
     then goto _90;
    for JJ:=1 to I do
     begin
      A[(JJ-1)+(J-1)*M] := AddC(A[(JJ-1)+(J-1)*M],MulC(T,A[(JJ-1)+(K-1)*M]));
_80:
     end;
_90:
    I := I + 1;
    if ( I >  K ) 
     then goto _110;
    JJ := I;
    while ( JJ<=K ) do
     begin
      A[(JJ-1)+(J-1)*M] := AddC(A[(JJ-1)+(J-1)*M],MulC(T,A[(JJ-1)+(K-1)*M]));
      A[(JJ+0)+(J-1)*M] := AddC(A[(JJ+0)+(J-1)*M],MulC(T,A[(JJ+0)+(K-1)*M]));
      A[(JJ+1)+(J-1)*M] := AddC(A[(JJ+1)+(J-1)*M],MulC(T,A[(JJ+1)+(K-1)*M]));
      A[(JJ+2)+(J-1)*M] := AddC(A[(JJ+2)+(J-1)*M],MulC(T,A[(JJ+2)+(K-1)*M]));
_100:
      inc(JJ,4);
     end;
_110:
_120:
   end;
_130:
_140:
 end;

{   BCEHE MATP INVERSE(U)*INVERSE(L) }
NM1 := N - 1;
if ( NM1 <  1 ) 
 then goto _270;
for KB:=1 to NM1 do
 begin
  K := N - KB;
  KP1 := K + 1;
  for I:=KP1 to N do
   begin
    Z[I-1] := A[(I-1)+(K-1)*M];
    A[(I-1)+(K-1)*M] := Cmplx(0.0,0.0);
_150:
   end;
  for J:=KP1 to N do
   begin
    T := Z[J-1];
    I := ((N) Mod (4));
    if ( I =  0 ) 
     then goto _170;
    for JJ:=1 to I do
     begin
      A[(JJ-1)+(K-1)*M] := AddC(A[(JJ-1)+(K-1)*M],MulC(T,A[(JJ-1)+(J-1)*M]));
_160:
     end;
_170:
    I := I + 1;
    if ( I >  N ) 
     then goto _190;
    JJ := I;
    while ( JJ<=N ) do
     begin
      A[(JJ-1)+(K-1)*M] := AddC(A[(JJ-1)+(K-1)*M],MulC(T,A[(JJ-1)+(J-1)*M]));
      A[(JJ+0)+(K-1)*M] := AddC(A[(JJ+0)+(K-1)*M],MulC(T,A[(JJ+0)+(J-1)*M]));
      A[(JJ+1)+(K-1)*M] := AddC(A[(JJ+1)+(K-1)*M],MulC(T,A[(JJ+1)+(J-1)*M]));
      A[(JJ+2)+(K-1)*M] := AddC(A[(JJ+2)+(K-1)*M],MulC(T,A[(JJ+2)+(J-1)*M]));
_180:
      inc(JJ,4);
     end;
_190:
_200:
   end;
  L := NLEAD[K-1];
  if ( L =  K ) 
   then goto _250;
  I := ((N) Mod (3));
  if ( I =  0 ) 
   then goto _220;
  for JJ:=1 to I do
   begin
    T := A[(JJ-1)+(L-1)*M];
    A[(JJ-1)+(L-1)*M] := A[(JJ-1)+(K-1)*M];
    A[(JJ-1)+(K-1)*M] := T;
_210:
   end;
_220:
  I := I + 1;
  if ( I >  N ) 
   then goto _240;
  JJ := I;
  while ( JJ<=N ) do
   begin
    T := A[(JJ-1)+(L-1)*M];
    A[(JJ-1)+(L-1)*M] := A[(JJ-1)+(K-1)*M];
    A[(JJ-1)+(K-1)*M] := T;
    T := A[(JJ+0)+(L-1)*M];
    A[(JJ+0)+(L-1)*M] := A[(JJ+0)+(K-1)*M];
    A[(JJ+0)+(K-1)*M] := T;
    T := A[(JJ+1)+(L-1)*M];
    A[(JJ+1)+(L-1)*M] := A[(JJ+1)+(K-1)*M];
    A[(JJ+1)+(K-1)*M] := T;
_230:
    inc(JJ,3);
   end;
_240:
_250:
_260:
 end;
_270:
end;

end.
